#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Nov 16 08:38:55 2017

@author: Salim
"""
import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm

fig = plt.figure()
ax = fig.add_subplot(111, projection='3d')


a = np.linspace(-3,3,100)
b = np.linspace(-3,3,100)
X,Y = np.meshgrid(a,b)

mu = np.array([0,0])
sigma = np.eye(2)

def gaussian(x,y):
    n = np.shape(x)[0]
    p = np.shape(x)[1]
    mult = np.zeros((n,p))
    for i in range(n):
        for j in range(p):
            v = np.array([x[i,j],y[i,j]])
            mult[i,j] = 1/(pow(2*3.14,3/2)*np.sqrt(np.linalg.det(sigma)))*np.exp(-0.5*np.dot(np.dot(np.transpose(v-mu),np.linalg.inv(sigma)),v-mu))
    return(mult)

Z = gaussian(X,Y)

ax.plot_surface(X, Y, Z,rstride=1, cstride=1, cmap=cm.jet, shade=True,
                   linewidth=0, antialiased=False)

    
    
    