#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar  7 10:14:56 2018

@author: Salim
"""

from sklearn.neighbors import KNeighborsRegressor
from sklearn.datasets import load_boston
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt
import numpy as np

boston = load_boston()

data = boston.data

idt = np.random.choice(range(data.shape[0]),size=40,replace=False)

y = boston.target[idt]

X = boston.data[idt,12].reshape(-1,1)

X_train, X_test, y_train, y_test = train_test_split(X,y,random_state=0)

fig, axes = plt.subplots(1, 3, figsize=(15,4))

Xmin = X.min()
Xmax = X.max()

line = np.linspace(Xmin,Xmax,1000).reshape(-1,1)

for n_neighbors, ax in zip([1, 3, 9], axes):
    reg = KNeighborsRegressor(n_neighbors=n_neighbors)
    reg.fit(X_train,y_train)
    ax.plot(line,reg.predict(line))
    ax.plot(X_train,y_train,'^',markersize=8)
    ax.plot(X_test,y_test,'v',markersize=8)
    
    ax.set_title(
            "{} neighbors\n train score : {:.2f} test score: {:.2f}".format(
                    n_neighbors, reg.score(X_train,y_train),
                    reg.score(X_test,y_test)))
    ax.set_xlabel("LSTAT")
    ax.set_ylabel("target")
    
axes[0].legend(["Model predictions","Training data/target",
    "Test data/target"],loc="best")