#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Dec 17 13:35:13 2017

@author: Salim
"""

# Matrice de nuages de points

import seaborn as sns

sns.set()

df = sns.load_dataset("iris")
sns_plot = sns.pairplot(df, hue= "species" , size = 2.5)
sns_plot.savefig("/Users/Salim/Desktop/pairs.png")

# Matrice des corrélations

from string import ascii_letters
import numpy as np
import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt

sns.set(style="white")

rs = np.random.RandomState(33) # Germe du générateur aléatoire
d = pd.DataFrame(data = rs.normal(size = (100,26)), columns = list(ascii_letters[26:]))

cor = d.corr()

mask = np.zeros_like(cor, dtype=np.bool)
mask[np.triu_indices_from(mask)] = True

f, ax = plt.subplots(figsize=(11, 9))

cmap = sns.diverging_palette(220, 10, as_cmap=True)

sns_plot = sns.heatmap(cor, mask=mask, cmap=cmap, vmax=.3, center=0,
            square=True, linewidths=.5, cbar_kws={"shrink": 1.})

fig = sns_plot.get_figure()
fig.savefig("/Users/Salim/Desktop/corrmat.png")
