#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Dec 17 12:46:56 2017

@author: Salim
"""

import numpy as np
import matplotlib.pyplot as plt

x = np.arange(100)
y = 150 + 3*x + 0.03*x**2 + 5*np.random.randn((len(x)))

M1 = np.vstack((np.ones_like(x),x)).T
M2 = np.vstack((np.ones_like(x), x, x**2)).T
M3 = np.vstack((np.ones_like(x), x, x**2, x**3)).T

p1 = np.linalg.lstsq(M1,y)
p2 = np.linalg.lstsq(M2,y)
p3 = np.linalg.lstsq(M3,y)

np.set_printoptions(precision=3)

print('The coefficients from the linear fit: {0}'.format(p1[0]))
print('The coefficients from the quadratic fit: {0}'.format(p2[0]))
print('The coefficients from the cubic fit: {0}'.format(p3[0]))

import statsmodels.api as sm

Res1 = sm.OLS(y, M1).fit()
Res2 = sm.OLS(y, M2).fit()
Res3 = sm.OLS(y, M3).fit()

print(Res1.summary2())
print(Res2.summary2())
print(Res3.summary2())

print('La valeur AIC est {0:4.1f} pour la régression linéaire, {1:4.1f} pour la régression quadratique, {2:4.1f} pour la régression cubique'.format(Res1.aic,Res2.aic,Res3.aic))



