#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Nov 23 09:39:59 2017

@author: Salim
"""

##############################################
## Programmation et Statistique avec Python ##
##############################################

#Construire un tableau a de dimensions 6 x 4 dont tous les éléments valent 2.

import numpy as np

a = 2*np.ones((6,4))
print(a)

#Construire un tableau b de dimensions 6 x 4 avec des 3 sur la diagonale et 1 partout 
#ailleurs (ne pas utiliser de boucle).

b = np.ones((6,4))+ 2*np.eye(6,4)
print(b)

#Peut-on multiplier ces matrices ? Pourquoi a*b fonctionne-t-il mais pas dot(a,b).

a*b # produit terme à terme OK
np.dot(a,b) #erreur : produit matriciel et les dimensions ne correspondent pas

#Calculer dot(a.transpose(),b) et dot(a,b.transpose()). 
#Pourquoi les résultats sont-ils de tailles différentes ?

np.dot(a.transpose(),b)
np.dot(a,b.transpose()) # résultats de tailles différentes (propriétés du produit matriciel)

#Ecrire une fonction qui imprime quelque chose à l’écran et vérifier que vous pouvez 
#l’exécuter sous Spyder.

def affiche():
    print("bonjour")
    
affiche()

#Ecrire une fonction qui génère des tableaux pseudo-aléatoires et affiche leurs sommes, 
#leurs valeurs moyennes, etc.

def tableau(n,p):
    a = np.random.rand(n,p)
    print(np.sum(a),np.mean(a),np.std(a))

tableau(2,3)

#Ecrire une fonction consistant en un ensemble de boucles parcourant un tableau pour 
#déterminer le nombre de 1 qu’il contient. 
#Faites la même chose à l’aide de la fonction where().

def nbones(a):
    n = np.shape(a)[0]
    p = np.shape(a)[1]
    compteur = 0
    for i in range(n):
        for j in range(p):
            if (a[i,j]==1):
                compteur = compteur + 1
    return(compteur)

a = np.ones((3,3)) + np.eye(3,3)
print(a)
nbones(a)

def nbones2(a):
    b = np.where(a==1,1,0)
    return(np.sum(b))

nbones2(a)

#Bibliographie :

#Introduction à l'Informatique avec Python - Serge Bays - Ellipses 2016
#Informatique avec Python - Serge Bays - Ellipses  2017
#Python pour les Maths - Amit Saha - Eyrolles 2015

#Ecrire un programme qui demande à l’utilisateur d’entrer une à une les coordonnées 
#de deux points dans le plan puis affiche la distance euclidienne entre ces deux points.

x1 = float(input('Abcisse du premier point ?'))
y1 = float(input('Ordonnée du premier point ?'))
x2 = float(input('Abcisse du deuxième point ?'))
y2 = float(input('Ordonnée du deuxième point ?'))

distance = ((x2-x1)**2+(y2-y1)**2)**0.5

print('La distance entre les deux points est :',distance)

#Ecrire un programme qui demande à l’utilisateur d’entrer son nom puis son prénom 
#et affiche les initiales.

nom = input('Entrer votre nom : ')
prenom = input('Entrer votre prénom : ')
print('Vos initiales sont : ',nom[0],prenom[0])

#Ecrire un programme qui demande à l’utilisateur d’entrer une chaîne de caractères puis 
#l’affiche encadrée par deux étoiles.

c = input("Entrer une chaîne de caractères : ")
print("*"+c+"*")

#Ecrire un programme qui demande à l’utilisateur d’entrer un mot puis affiche un message 
#disant si ce mot a plus de huit lettres ou pas et donne la longueur du mot.

mot = input("Entrer un mot : ")
if len(mot) > 8:
    print("Le mot a plus de huit lettres")
    print("Il a ",len(mot)," lettres.")
else:
    print("Le mot n'a pas plus de huit lettres")
    print("Il a ",len(mot)," lettres.")


#Ecrire un programme qui demande à l’utilisateur d’entrer deux nombres et affiche 
#un message précisant la différence entre le plus grand et le plus petit.
    
x = float(input("Entrer un premier nombre  : "))
y = float(input("Entrer un deuxième nombre : "))

d = x-y
if d<0:
    d = -d
print("La différence est : ",d)

#Ecrire un programme qui résout l’équation du second degré a*x**2+b*x+c=0. 
#Le programme demande les valeurs de a, b, c à l’utilisateur et affiche le nombre de 
#solutions et leurs valeurs éventuelles.

a = float(input('Valeur de a (non nulle) : '))
b = float(input('Valeur de b : '))
c = float(input('Valeur de c : '))

delta = b*b-4*a*c

if delta < 0:
    print('Pas de solution.')
else:
    x1 = (-b-delta**0.5)/(2*a)
    if delta == 0:
        print('Une solution : ',x1)
    else:
        x2 = (-b+delta**0.5)/(2*a)
        print('Deux solutions : ',x1,' et ',x2)
        
#Ecrire un programme qui demande à l’utilisateur d’entrer trois nombres entiers 
#naturels x, y, z, puis affiche la plus petite valeur.
        
x = int(input('Premier entier : '))
y = int(input('Deuxième entier : '))
z = int(input('Troisième entier : '))

if x<y and x<z:
    print('La plus petite valeur est ',x)
elif y<z:
    print('La plus petite valeur est ',y)
else:
    print('La plus petite valeur est ',z)
    
#Ecrire un programme qui demande à l’utilisateur d’entrer un entier strictement 
#positif k et qui affiche les k premiers carrés non nuls.
    
k = int(input('Entrer un entier strictement positif k : '))

print("Les ",k," premiers carrés non nuls sont ")
for i in range(1,k+1):
    print(i*i,end = ' ')
# end= ' ' remplace le retour à la ligne par un espace
    
#Ecrire un programme qui demande à l’utilisateur d’entrer une chaîne de caractères 
#et qui affiche une nouvelle chaîne de caractères composée uniquement des voyelles de 
#la chaîne initiale.
    
c = input("Entrer une chaîne de caractères : ")

v = ''

for lettre in c:
    if lettre in 'aeiouyAEIOUY':
        v += lettre

print("Les voyelles sont : ", v)

#Ecrire un programme qui demande à l’utilisateur d’entrer une chaîne de caractères 
#et qui affiche les voyelles de la chaîne avec leur position dans la chaîne.

c = input("Entrer une chaîne de caractères : ")

v = ''

for i in range(len(c)):
    if c[i] in 'aeiouyAEIOUY':
        print(c[i],i,end=' ')



#Un jeu consiste à lancer une pièce de monnaie; tant que Pile apparaît, 
#on relance la pièce; si c’est Face qui apparaît le jeu se termine. 
#Les instructions :

#from random import randint
#a = randint(0,1)

#permettent d’affecter à la variable a la valeur 0 ou 1 de façon équiprobable et 
#de simuler ainsi le jeu de Pile ou Face.
#Ecrire un programme qui compte le nombre de fois où Pile est apparu au cours d’un jeu.
#Compléter le programme afin de simuler cent fois ce jeu et d’afficher en sortie le 
#nombre maximal de fois où Pile est apparu au cours d’un jeu.
        
from random import randint

a = randint(0,1)

if a==0:
    print('P')
else:
    print('F')
    
cpt = 0

while a == 0:
    cpt +=1
    a = randint(0,1)
    if a==0:
        print('P')
    else:
        print('F')
print(cpt,' fois Pile.')

#Simulation

maxi = 0
for i in range(100):
    a = randint(0,1)
    cpt = 0
    while a == 0:
        cpt += 1
        if cpt > maxi:
            maxi = cpt
        a = randint(0,1)
print('Le maximum est ',maxi,' fois Pile.')


#Ecrire une fonction qui prend en argument une chaîne de caractères et affiche 
#la valeur True si cette chaîne contient le caractère « e » et la valeur False sinon. 
#La fonction sera ensuite testée sur une chaîne entrée au clavier par l’utilisateur.

def contient_e(c):
    if 'e' in c:
        print(True)
    else:
        print(False)
        
chaine = input('Entrer une chaîne de caractères : ')
contient_e(chaine)

#Ecrire une fonction qui prend en argument une chaîne de caractères et qui détermine 
#puis renvoie le nombre d’occurrences du caractère « e » dans cette chaîne. 
#La fonction sera ensuite testée sur une chaîne entrée au clavier par l’utilisateur.

def compteur_e(c):
    cpt = 0
    for lettre in c:
        if lettre == 'e':
            cpt += 1
    return cpt

chaine = input('Entrer une chaîne de caractères : ')
compteur_e(chaine)

#Ecrire une fonction qui prend en argument une chaîne de caractères et renvoie une 
#nouvelle chaîne de caractères en insérant un tiret ‘-‘ entre chaque caractère de la 
#chaîne initiale.

def tiret(c):
    cTiret = c[0]
    for i in range(1,len(c)):
        cTiret += '-' + c[i]
    return cTiret

#Ecrire une fonction qui prend en argument une chaîne de caractères et renvoie 
#la chaîne écrite à l’envers
    
def inverse(c):
    n = len(c)
    if n == 0:
        return ""
    cInverse = c[-1]
    for i in range(1,n):
        cInverse += c[-1-i]
    return cInverse

#Version courte
    
def inverse(c):
    return c[-1::-1] if len(c) > 0 else ""

#Ecrire une fonction qui calcule la médiane d’une liste de nombres. 
#L’appliquer à une liste de 10 nombres aléatoires.
    
import numpy as np

def calcul_mediane(nombres):
    N = len(nombres)
    nombres.sort()
    if N%2 == 0:
        m1 = N/2
        m2 = (N/2)+1
        m1 = int(m1)-1
        m2 = int(m2)-1
        mediane = (nombres[m1]+nombres[m2])/2
    else:
        m =(N+1)/2
        m = int(m)-1
        mediane = nombres[m]
    return mediane

if __name__ == '__main__':
    donnees = list(np.random.rand(10))
    mediane = calcul_mediane(donnees)
    N = len(donnees)
    print('La médiane pour les {0} individus est {1}.'.format(N,mediane))


#En important la classe Counter du package collections, écrire une fonction qui 
#détermine le mode d’une liste de nombres. L’appliquer à une liste de 10 nombres 
#aléatoires à valeurs 0 et 1. On pourra utiliser la méthode most.common( ) de la 
#classe Counter.
    
from collections import Counter
import numpy as np

def calcul_mode(nombres):
    c = Counter(nombres)
    mode = c.most_common(1)
    return mode[0][0]

if __name__=='__main__':
    data = list(np.random.randint(low=0,high=2,size=10))
    mode = calcul_mode(data)
    print('Le mode de {0} est : {1}.'.format(data,mode))
    
#Ecrire une fonction qui détermine la distribution de fréquences d’une liste de nombres. 
#On pourra utiliser la classe Counter du package collections.
    
from collections import Counter
import numpy as np

def table_frequences(nombres):
    table = Counter(nombres)
    print('Nombre\tOcurrences')
    for nombre in table.most_common():
        print('{0}\t{1}'.format(nombre[0],nombre[1]))

if __name__=='__main__':
    data = list(np.random.randint(low=0,high=2,size=10)) 
    table_frequences(data)
    
#Ecrire une fonction qui détermine la variance et l’écart- type d’une liste de nombres.

import numpy as np

def calcul_moyenne(nombres):
    s = sum(nombres)
    N = len(nombres)
    moyenne = s/N
    return moyenne

def differences(nombres):
    moyenne = calcul_moyenne(nombres)
    diff = []
    for num in nombres:
        diff.append(num-moyenne)
    return diff

def calcul_variance(nombres):
    diff = differences(nombres)
    carre_diff = []
    for d in diff:
        carre_diff.append(d**2)
    somme_carre_diff = sum(carre_diff)
    variance = somme_carre_diff/len(nombres)
    return variance

def calcul_ecart_type(nombres):
    return calcul_variance(nombres)**0.5

if __name__=='__main__':
    data = list(np.random.randn(10)) 
    var = calcul_variance(data)
    et = calcul_ecart_type(data)
    print('La variance des données est {0} et leur écart-type {1}'.format(var,et))

# A partir de l’observation x**(2*k) = (x**k)**2 et x**(2*k+1) =x*(x**k)**2, écrire 
# une fonction récursive prenant en paramètre un nombre x quelconque et un entier 
# naturel n et renvoyant la valeur x**n.
    
def puissance(x,n):
    if n == 0:
        return 1
    else:
        p = puissance(x,n//2)
        if n%2 == 0:
            return p*p
        else:
            return x*p*p

puissance(2,4)



