import pickle
import flask
import numpy as np
from flask import request

app = flask.Flask(__name__)

#loading my model
model = pickle.load(open("model.pkl","rb"))

#defining a route for only post requests
@app.route('/predict', methods=['POST'])
def predict():
  
        #getting an array of features from the post request's body
        query_parameters = request.args
        feature_array = np.fromstring(query_parameters['feature_array'],dtype=float,sep=",")

        #creating a response object
        #storing the model's prediction in the object
        response = {}
        response['predictions'] = model.predict([feature_array]).tolist()
  
        #returning the response object as json
        return flask.jsonify(response)

if __name__ == "__main__":
    app.run(debug=True)